.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	EaxVal equ <12345>
	REPEAT 2
		tmp$ CATSTR <print chr$(13, 10, "Results for eax=>, EaxVal, <:", 13, 10)>
		% echo tmp$
		tmp$
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, EaxVal
				@@:
				neg eax                            ;exit only
				shr eax, 1                         ;if 0 or -1
				jz     @B
		ENDM
		counter_end
		print str$(eax), 9, "cycles for neg", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, EaxVal
				@@:
				inc eax
				je @B
				dec eax
				je @B
		ENDM
		counter_end
		print str$(eax), 9, "cycles for inc+dec", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, EaxVal
				@@:
				test eax, eax
				jg @F
				inc eax
				je @B
		@@:
		ENDM
		counter_end
		print str$(eax), 9, "cycles for test+inc", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, EaxVal
;				int 3
				@@:
				dec eax
				jge @F
				inc eax
				je @B
		@@:
		ENDM
		counter_end
		print str$(eax), 9, "cycles for dec+inc", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, EaxVal
				@@:
				inc eax
				shr eax, 1
				jz @B
		@@:
		ENDM
		counter_end
		print str$(eax), 9, "cycles for inc+shr", 13, 10
		EaxVal equ <-12345>
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)

Results for eax=12345:
181     cycles for neg
311     cycles for inc+dec
156     cycles for test+inc
200     cycles for dec+inc

Results for eax=-12345:
187     cycles for neg
312     cycles for inc+dec
272     cycles for test+inc
308     cycles for dec+inc
